Imports System.Threading
'NOTE: This example application shows how to use the SP_ prefixed DLL functions to initialized prior to doing
'  a scan. 
'If you are a developer creating a new application, or able to easily change functions within your existing 
'  application, we encourage you to make use of the new  EX_  prefixed function calls as documented within
'  the webpage that the link below will take you to:
'       http://www.lawsonlabs.com/Download/Manuals-Drivers/Model_301_302/M30x_SP_X/Shared/ArchiveContents/_HTML_docs/FunctionUsage/FuncUse.htm
'  the same link condensed for easy copy:
'       http://tinyurl.com/62qp6a
'Using CTRL + "left mouse button" will load the page here for you.
'Links from the main page: http://www.lawsonlabs.com to the developer's section will provide additional
'  links for other software language examples, answers to some frequently asked questions, links to prototypes
'  and related information for the older API's, as well as other reference material.

'This example uses default configuration. There are many configuration options, but they are not shown here 
'in an attempt to keep the code simple.

'Note the required lines of code for setting up the "SCAN_OBJECT" structure for passing to the DLL.

Public Class Form1
    <Runtime.InteropServices.StructLayout(Runtime.InteropServices.LayoutKind.Sequential, Pack:=4)> _
    Structure SCAN_OBJECT
        Public SO_bScanType As Byte
        Public SO_dblDevRate As Double
        Public SO_iTotalPointsReadByDrvr, SO_iPointsInBuffer, SO_iStatus, SO_iSizeVoltageArray, SO_iCurHead, SO_iCurTail As Integer
        Public SO_bDigitalInput, SO_bChecksum, SO_DeviceDisconnect As Byte
        Public SO_iScanStartTime, SO_iScanEndTime As Integer
        Public SO_bScanArg As Byte 'number of scan channels in multi-chan scan
    End Structure
    'Public ScanObjectArray() As SCAN_OBJECT
    Public scanChanVolts(8), scanChanDig(8) As TextBox, scanChanLabels(8) As Label
    Public fSignedOn, fScanRunning, fRetValMisc, fScanPause As Boolean
    Public usCurDevID As Short, lRawCountArray() As Integer
    Public bDiginBuff() As Byte
    Public Const SINGLE_CHAN_SCAN As Short = 1 : Public Const MULTI_CHAN_SCAN As Short = 2
    Public Const MULTI_CHAN_CAL_SCAN As Short = 3 : Public Const SINGLE_CHAN_DIGIN_SCAN As Short = 4
    Public Const MULTI_CHAN_DIGIN_SCAN As Short = 5 : Public Const MULTI_CHAN_CAL_DIGIN_SCAN As Short = 6
    Declare Function DLL_StartScan_DIO Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByRef ScanObject As SCAN_OBJECT, ByVal bStartMode As Byte) As Byte
    'Declare Function DLL_ReadScanData_DIO Lib "LL_USB2k.DLL" (ByVal usDevID As Short, ByRef iDynaVoltageBuff As Integer, ByVal numPointsToRead As Short, ByRef ScanObject As SCAN_OBJECT) As Byte
    Declare Function DLL_ReadScanDataWithDigin Lib "LL_USB2k.DLL" (ByVal usDevID As Short, ByRef iDynaVoltageBuff As Integer, ByRef bDynaDiginBuff As Byte, ByRef bCurScanChan As Byte, ByVal numPointsToRead As Short, ByRef ScanObject As SCAN_OBJECT) As Byte
    Declare Function DLL_EndScan_DIO Lib "LL_USB2k.DLL" (ByVal uiDevId As Short, ByVal fEmptyBuffer As Byte, ByVal uiTimeOut_NOT_CURRENTLY_USED As Integer, ByVal bScanPauseOrTerminate_NOT_CURRENTLY_USED As Byte) As Byte
    Declare Function SP_InitAllDevices Lib "LL_USB2k.DLL" _
      (ByRef pusDevList As Short, ByRef bDevCnt As Byte, ByRef dblRate As Double, ByVal fShowDevList As Byte) As Byte
    Declare Function SP_SendChan Lib "LL_USB2k.DLL" (ByVal usDeviceID As Short, ByVal bCurChan As Byte, ByRef pbDigInput As Byte) As Byte
    Declare Function SP_SendRate Lib "LL_USB2k.DLL" (ByRef dblRate As Double, ByVal usDeviceID As Short) As Byte
    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Dim sLLABS_DeviceIDList(32) As Short : sLLABS_DeviceIDList(0) = txtDevID.Text
        btnConnect.Enabled = False : btnScan.Enabled = False : btnExit.Enabled = False
        usCurDevID = txtDevID.Text
        Dim dblRate(32) As Double : dblRate(0) = comboRate.Text : Dim bRetVal, bChan, bDevCnt As Byte : bChan = 0
        Msgs.Text = "Initializing at " & dblRate(0) & "Hz, channel " & bChan & "  -> wait. . . " & vbCrLf : System.Windows.Forms.Application.DoEvents()
        sLLABS_DeviceIDList(0) = txtDevID.Text
        bRetVal = SP_InitAllDevices(sLLABS_DeviceIDList(0), bDevCnt, dblRate(0), 1)
        If bRetVal = 0 Then
            Msgs.Text = Msgs.Text & "SP_InitAllDevices() failed" & vbCrLf : System.Windows.Forms.Application.DoEvents()
            btnConnect.Enabled = True : btnExit.Enabled = True : Exit Sub
        End If
        Msgs.Text = Msgs.Text & "SP_InitAllDevices() success" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        fSignedOn = True : btnScan.Focus() : System.Windows.Forms.Application.DoEvents()
        btnScan.Enabled = True : btnScanStop.Enabled = False : lblMainChan.Enabled = True
        comboMainChan.Enabled = True : comboScanChans.Enabled = True : lblScanChans.Enabled = True : chkCalScan.Enabled = True
        Msgs.Text = Msgs.Text & "Successful initialization" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        btnConnect.Enabled = True : btnScan.Enabled = True : btnExit.Enabled = True
    End Sub
    Private Sub btnScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScan.Click
        Dim numTotalChans, bRetVal, bCurScanChan, bModVal As Byte
        Dim mscIndex, numPointsToRead, numPointsPerScan, iCalScanChanOffset As Integer
        Dim ScanObjectArray As New SCAN_OBJECT : Dim avgVal, dblCalVal, dVoltageSingConv As Double
        numTotalChans = (comboScanChans.Text + chkCalScan.CheckState)
        If numTotalChans > 8 Then numTotalChans = 8
        ScanObjectArray.SO_bScanType = SINGLE_CHAN_DIGIN_SCAN
        If comboScanChans.Text > 1 Then ScanObjectArray.SO_bScanType = MULTI_CHAN_DIGIN_SCAN
        If chkCalScan.Checked Then : ScanObjectArray.SO_bScanType = MULTI_CHAN_CAL_DIGIN_SCAN
        Else
            For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Text = "" : scanChanDig(mscIndex).Text = "" : Next mscIndex
            For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Enabled = False : scanChanDig(mscIndex).Enabled = False : scanChanLabels(mscIndex).Enabled = False : Next mscIndex
            For mscIndex = 0 To numTotalChans - 1 : scanChanVolts(mscIndex).Enabled = True : scanChanDig(mscIndex).Enabled = True : scanChanLabels(mscIndex).Enabled = True : Next mscIndex
        End If
        If chkCalScan.Checked Then : scanChanVolts(7).Enabled = True : scanChanDig(7).Enabled = True : End If

        'SO_bScanArg is set to scan channels chosen in scanning channels
        'The calibration channel, 7, is not counted unless the actual channels selected is also 7
        ScanObjectArray.SO_bScanArg = numTotalChans - CByte(chkCalScan.CheckState)
        ScanObjectArray.SO_bScanArg = CByte(comboScanChans.Text)
        ScanObjectArray.SO_dblDevRate = CDbl(comboRate.Text)

        Msgs.Text = Msgs.Text & "DLL_StartScan_DIO()-> WAIT" & vbCrLf : System.Windows.Forms.Application.DoEvents()

        bRetVal = DLL_StartScan_DIO(usCurDevID, ScanObjectArray, 1)
        If bRetVal Then
            Msgs.Text = Msgs.Text & "success starting scan" & vbCrLf
            btnScan.Enabled = False : btnPause.Enabled = True : comboRate.Enabled = False : lblRate.Enabled = False : comboScanChans.Enabled = False : lblScanChans.Enabled = False : lblScanChans.Enabled = False : chkCalScan.Enabled = False : btnExit.Enabled = False : btnConnect.Enabled = False : btnScanStop.Enabled = True : btnScanStop.Focus() : System.Windows.Forms.Application.DoEvents()
            bCurScanChan = 0 : bModVal = comboScanChans.Text : fScanPause = False : btnPause.Text = "pause data read"
            If (chkCalScan.Checked) And (comboScanChans.Text > 1) And (comboScanChans.Text < 8) Then bModVal += 1
            numPointsPerScan = numTotalChans
            fScanRunning = True

            'this array has to be sized according to the number of points it's going to hold
            ReDim lRawCountArray(numPointsPerScan), bDiginBuff(numPointsPerScan)
            dblCalVal = 0.0 : Dim bval As Long
            While fScanRunning = True
                'lblScanChans.Enabled = False
                System.Windows.Forms.Application.DoEvents()

                'call with no data request, just to get number of points in buffer
                bRetVal = DLL_ReadScanDataWithDigin(usCurDevID, lRawCountArray(0), bDiginBuff(0), bCurScanChan, 0, ScanObjectArray)
                txtBuffPoints.Text = ScanObjectArray.SO_iPointsInBuffer : txtBuffPoints.Update()


                'this is just for testing. It allows the DLL's buffer to fill up so we can test the code
                ' below that loops until it gets all the scans out of the buffer
                If fScanPause Then : bval = 0 : Continue While : End If

                'nothing to do unless we have at least one scan
                If ScanObjectArray.SO_iPointsInBuffer < numPointsPerScan Then Continue While

                'can add the following just to make sure your buffer is read correctly, since it will read
                ' only after 4 scans are in the buffer
                If ScanObjectArray.SO_iPointsInBuffer < (numPointsPerScan * 4) Then Continue While

                'read however many channels there are
                numPointsToRead = (CInt(ScanObjectArray.SO_iPointsInBuffer / numPointsPerScan)) * numPointsPerScan
                'Msgs.Text = ("numPointsToRead: " & numPointsToRead & ", in buff: " & ScanObjectArray.SO_iPointsInBuffer & ", numPointsPerScan: " & numPointsPerScan)

                ReDim lRawCountArray(numPointsToRead), bDiginBuff(numPointsToRead)
                bRetVal = DLL_ReadScanDataWithDigin(usCurDevID, lRawCountArray(0), bDiginBuff(0), bCurScanChan, numPointsToRead, ScanObjectArray)
                If bRetVal Then

                    iCalScanChanOffset = numPointsPerScan - 1
                    For mscIndex = 0 To numPointsToRead - 1
                        System.Windows.Forms.Application.DoEvents()
                        'NOTE:
                        'if cal scan with 3 channels selected, and if there are 3 scans in the buffer, 
                        'then the buffer will look like this showing channel data, with cal data shown as channel 7:
                        '[0,1,2,7][0,1,2,7][0,1,2,7]
                        'IMPORTANT: even though all channels in a multi-channel scan are read sequentially from the
                        ' device, the channels between the last channel and channel 7 can be skipped in a cal scan
                        ' since the hardware reads channel 7 independently. In other words, if you are doing a 3-channel
                        ' cal scan, then channel 0, channel 1, and channel 2 will be read by the hardware, and then it 
                        ' will read channel 7. The cal scan is the only exception to the sequential reading of channel rule.
                        ' Because of this scenario, the DLL's buffer will contain those first three channels, followed by
                        '  the data from channel 7. If you are doing an 8 channel cal-scan, then the hardware and DLL acts
                        '  the same way as if you are doing an 8 channel, non-cal scan.
                        If chkCalScan.Checked Then
                            If mscIndex Then : If (mscIndex Mod numPointsPerScan) = 0 Then iCalScanChanOffset += numPointsPerScan
                            End If
                            'Msgs.Text = iCalScanChanOffset & ", " & numPointsPerScan : Msgs.Update()
                            dblCalVal = ((lRawCountArray(iCalScanChanOffset) - 8388608) * 0.00000059604645)
                            scanChanVolts(7).Text = Format(dblCalVal, "#####.000000")
                        End If : avgVal = 0

                        'if cal-scan then the voltage from the calibration channel (7) will be subtracted from
                        ' each channel, otherwise nothing is subtracted since dblCalVal is set to 0 at top.
                        dVoltageSingConv = ((lRawCountArray(mscIndex) - 8388608) * 0.00000059604645) - dblCalVal

                        'NOTE: the MODding of the data used various places below is only used to make it easier to 
                        'organize the data coming out of the array for multiple channels, into the correct display boxes.
                        If comboScanChans.Text = 1 Then
                            scanChanVolts(mscIndex Mod bModVal).Text = Format(dVoltageSingConv, "#####.000000")
                            scanChanDig(mscIndex Mod bModVal).Text = bDiginBuff(mscIndex)
                            Continue For
                        End If

                        If mscIndex Then
                            'for display and test purpose only!
                            'if more one scan is to be displayed, then have a small delay between displaying
                            ' each scan, just so we can see that the data is not scrambled when multiple
                            ' scans are read from the buffer. txtWaitLoops just shows how many times we did this
                            If ((mscIndex Mod numTotalChans) = 1) And (mscIndex > (numTotalChans * 2)) Then
                                'Dim waitTime As New TimeSpan(0, 0, 0, 0, 50): Thread.Sleep(waitTime)
                                Thread.Sleep(Int(20000 / Int(comboRate.Text)))
                                bval += 1 : txtWaitLoops.Text = bval
                            End If
                        End If

                        'the following just prevents showing the data from cal scan in the wrong box
                        If (CByte(mscIndex \ bModVal) = 1) And CByte(chkCalScan.CheckState) Then Continue For

                        'if here, then it's multi-channel scan so make sure all data gets into the correct box
                        scanChanVolts(mscIndex Mod bModVal).Text = Format(dVoltageSingConv, "#####.000000")
                        scanChanDig(mscIndex Mod bModVal).Text = bDiginBuff(mscIndex)
                        scanChanVolts(mscIndex Mod bModVal).Update()
                        scanChanDig(mscIndex Mod bModVal).Update()
                        If Not fScanRunning Then Exit For

                    Next mscIndex
                End If
            End While
            bRetVal = DLL_EndScan_DIO(usCurDevID, 0, 0, 0) : fScanRunning = False
            Msgs.Text = "scan stopped" & vbCrLf : btnScan.Enabled = True : chkCalScan.Enabled = True
            comboRate.Enabled = True : lblRate.Enabled = True : comboScanChans.Enabled = True : lblScanChans.Enabled = True : btnConnect.Enabled = True : btnExit.Enabled = True : btnScanStop.Enabled = False : btnScan.Focus() : System.Windows.Forms.Application.DoEvents()
        Else
            Msgs.Text = Msgs.Text & "failed to start scan" & vbCrLf : fScanRunning = False
        End If
        Msgs.Text = Msgs.Text & "exiting scanning" & vbCrLf : btnPause.Enabled = False
    End Sub
    Private Sub btnScanStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScanStop.Click
        If fScanRunning = True Then
            Msgs.Text = "Stopping scan - please wait...." & vbCrLf
            btnScanStop.Enabled = False
            System.Windows.Forms.Application.DoEvents()
            fScanRunning = False
        End If
    End Sub
    Private Sub btnStopScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If fScanRunning = True Then
            Msgs.Text = "Stopping scan - please wait...." & vbCrLf
            btnScanStop.Enabled = False
            System.Windows.Forms.Application.DoEvents()
            fScanRunning = False
        End If
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboMainChan.SelectedIndexChanged
        Dim bRetVal, bCurChan As Byte
        bRetVal = SP_SendChan(usCurDevID, comboMainChan.Text, bCurChan)
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        fSignedOn = False : fScanRunning = False
        scanChanVolts(0) = txtVolts0 : scanChanVolts(1) = txtVolts1 : scanChanVolts(2) = txtVolts2 : scanChanVolts(3) = txtVolts3 : scanChanVolts(4) = txtVolts4 : scanChanVolts(5) = txtVolts5 : scanChanVolts(6) = txtVolts6 : scanChanVolts(7) = txtVolts7
        scanChanDig(0) = txtDig0 : scanChanDig(1) = txtDig1 : scanChanDig(2) = txtDig2 : scanChanDig(3) = txtDig3 : scanChanDig(4) = txtDig4 : scanChanDig(5) = txtDig5 : scanChanDig(6) = txtDig6 : scanChanDig(7) = txtDig7
        scanChanLabels(0) = lblChan0 : scanChanLabels(1) = lblChan1 : scanChanLabels(2) = lblChan2 : scanChanLabels(3) = lblChan3 : scanChanLabels(4) = lblChan4 : scanChanLabels(5) = lblChan5 : scanChanLabels(6) = lblChan6 : scanChanLabels(7) = lblChan7
        lblScanChans.Enabled = False
        usCurDevID = 0 : fScanPause = False
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        If fScanRunning = True Then
            Msgs.Text = Msgs.Text & "stopping scan - WAIT" & vbCrLf : System.Windows.Forms.Application.DoEvents()
            While fScanRunning = True : System.Windows.Forms.Application.DoEvents() : End While
        End If
        fScanRunning = False : Form1.ActiveForm.Close()
    End Sub
    Private Sub comboScanChans_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboScanChans.SelectedIndexChanged
        Dim mscIndex As Byte
        For mscIndex = comboScanChans.Text To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Text = "" : scanChanDig(mscIndex).Text = "" : Next mscIndex
        For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Enabled = False : scanChanDig(mscIndex).Enabled = False : scanChanLabels(mscIndex).Enabled = False : Next mscIndex
        For mscIndex = 0 To comboScanChans.Text - 1 : scanChanVolts(mscIndex).Enabled = True : scanChanDig(mscIndex).Enabled = True : scanChanLabels(mscIndex).Enabled = True : Next mscIndex
        If chkCalScan.Checked Then : scanChanVolts(7).Text = "" : scanChanDig(7).Text = "" : scanChanVolts(7).Enabled = True : scanChanDig(7).Enabled = True : scanChanLabels(7).Enabled = True
        Else : scanChanVolts(7).Enabled = False : scanChanDig(7).Enabled = False : scanChanLabels(7).Enabled = False : End If
    End Sub
    Private Sub comboRate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboRate.SelectedIndexChanged
        If fSignedOn Then
            PanelWait.Location = New Point(12, 100)
            Msgs.Text = "Sending rate - wait. . ." & vbCrLf : System.Windows.Forms.Application.DoEvents()
            SP_SendRate(CDbl(comboRate.Text), usCurDevID)
            PanelWait.Location = New Point(16, 286)
            Msgs.Text = Msgs.Text & "Rate sent" & vbCrLf : System.Windows.Forms.Application.DoEvents()
        End If
    End Sub
    Private Sub chkCalScan_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCalScan.CheckStateChanged
        Dim mscIndex As Byte
        For mscIndex = 0 To comboScanChans.Items.Count - 1 : scanChanVolts(mscIndex).Enabled = False : scanChanDig(mscIndex).Enabled = False : scanChanLabels(mscIndex).Enabled = False : Next mscIndex
        For mscIndex = 0 To comboScanChans.Text - 1 : scanChanVolts(mscIndex).Enabled = True : scanChanDig(mscIndex).Enabled = True : scanChanLabels(mscIndex).Enabled = True : Next mscIndex
        For mscIndex = 0 To comboScanChans.Text - 1 : scanChanVolts(mscIndex).Text = "" : scanChanDig(mscIndex).Text = "" : Next mscIndex
        If chkCalScan.Checked Then : scanChanVolts(7).Text = "" : scanChanVolts(7).Enabled = True : scanChanDig(7).Enabled = True : scanChanLabels(7).Enabled = True
        Else : scanChanVolts(7).Enabled = False : scanChanDig(7).Enabled = False : scanChanLabels(7).Enabled = False : End If
    End Sub
    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click
        If fScanPause Then
            btnPause.BackColor = System.Drawing.Color.FromName("Control")
            fScanPause = False : btnPause.Text = "pause scan read"
        Else
            btnPause.BackColor = System.Drawing.Color.FromArgb(255, 200, 200)
            fScanPause = True : btnPause.Text = "data read paused"
        End If
    End Sub

    Private Sub chkCalScan_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkCalScan.CheckedChanged
        'MsgBox(chkCalScan.CheckState)
    End Sub
End Class

' more prototypes and other information for new DLL:
'   http://www.lawsonlabs.com/Download/Manuals-Drivers/Model_301_302/Docs/30xmain.php?model=301



